# skript-mirror

skript-mirror is a robust reflection addon for advanced scripters. It aims to combine the capabilities of Java with the easy-to-use development environment of Skript.

[Documentation](https://skript-mirror.gitbook.io/docs/) \| [Source](https://github.com/btk5h/skript-mirror)

## Should I use skript-mirror?

If you were given a script or a code snippet that requires skript-mirror, the answer is: absolutely!

If you're looking to add skript-mirror to your scripting toolbox, it is highly recommended that you familiarize yourself with the basics of Java or another object-oriented programming language.

Are you considering writing an addon for Skript? Consider implementing your features in skript-mirror instead! skript-mirror offers several advantages over a traditional Skript addon:

* Writing addons properly is difficult, especially if you're new to Java. skript-mirror will handle most of the boilerplate for you, allowing you to focus on maintaining high-quality Skript extensions.
* Extensions written in skript-mirror can be tested quickly, just like any other script. Unlike a Skript addon, which requires compilation and a complete server restart, skript-mirror scripts can be refreshed with a simple `sk reload`.
* Some features may require you to use reflection to access private methods, fields, and constructors. skript-mirror's built-in reflection allows you to access these private members seamlessly.
* One of Skript's essential features is its customizability. Extensions written in skript-mirror promote this, allowing users to quickly make changes to your code, if necessary.



